//+------------------------------------------------------------------+
//|                                                 Gideons_ATR.mq4  |
//|                       Copyright  2007, GideonSmolders@gmail.com |
//|                                           MetaTrader Group Yahoo |
//+------------------------------------------------------------------+
//mod2008fxtsd
#property copyright "Copyright  2007, GideonSmolders"
#property link      ""
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Silver
#property  indicator_color2  Red
//---- indicator parameters
extern int       atr_fast=5;
extern int       atr_slow=48;
extern int       atr_SigL=7;

//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
double     atr1[];
double     atr2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//  IndicatorBuffers (4);
/// ///---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(0,atr_fast);
   SetIndexDrawBegin(1,atr_slow*4);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
//---- indicator buffers mapping
   if(!SetIndexBuffer(0,ind_buffer1) && !SetIndexBuffer(1,ind_buffer2))
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Gideons ATR ("+atr_fast+"/"+atr_slow+", "+atr_SigL+") ");
   SetIndexLabel(0,"ATR_Signal");
   SetIndexLabel(1,"MA");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
int start()
 {
   int i,limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
  
   limit=Bars-counted_bars;
   

 
   for(i=limit; i>=0; i--)
   {  
   double atr1=iATR(NULL,0,atr_fast,i);
   double atr2=iATR(NULL,0,atr_slow,i);


   if (atr1 !=0 && atr2 !=0)
   ind_buffer1[i] = atr1/atr2-1;
   
   }

   for(i=limit; i>=0; i--)
 
    ind_buffer2[i]=iMAOnArray(ind_buffer1,0,atr_SigL,0,MODE_SMMA,i);
       
//---- 
   return(0);
 }
//+------------------------------------------------------------------+